﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace JonathanHaas.ActiveVB.WB3
{
    public class DirectPath : IComparable<DirectPath>
    {
        private PathNode _startNode;
        private PathNode _endNode;

        public DirectPath(PathNode startNode, PathNode endNode)
        {
            _startNode = startNode;
            _endNode = endNode;
        }

        public int CompareTo(DirectPath other)
        {
            return lengthSquared.CompareTo(other.lengthSquared);
        }

        public double lengthSquared
        {
            get
            {
                return length(_startNode, _endNode);
            }
        }

        public static double length(PathNode startNode, PathNode endNode)
        {
            var dx = endNode.X - startNode.X;
            var dy = endNode.Y - startNode.Y;
            return Math.Sqrt(dx * dx + dy * dy);
        }

        public PathNode startNode
        {
            get
            {
                return _startNode;
            }
        }

        public PathNode endNode
        {
            get
            {
                return _endNode;
            }
        }
    }
}
