﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace JonathanHaas.ActiveVB.WB3
{
    class ThreeNodePath : IComparable<ThreeNodePath>
    {
        private PathNode _firstNode;
        private PathNode _midNode;
        private PathNode _lastNode;

        public ThreeNodePath(PathNode firstNode, PathNode midNode, PathNode lastNode)
        {
            _firstNode = firstNode;
            _midNode = midNode;
            _lastNode = lastNode;
        }

        public PathNode FirstNode
        {
            get
            {
                return _firstNode;
            }
        }

        public PathNode MidNode
        {
            get
            {
                return _midNode;
            }
        }

        public PathNode LastNode
        {
            get
            {
                return _lastNode;
            }
        }

        public double Length
        {
            get
            {
                return DirectPath.length(_firstNode, _midNode) + DirectPath.length(_midNode, _lastNode);
            }
        }

        public double FirstSegmentLength
        {
            get
            {
                return DirectPath.length(_firstNode, _midNode);
            }
        }

        public double LastSegmentLength
        {
            get
            {
                return DirectPath.length(_midNode, _lastNode);
            }
        }

        public int CompareTo(ThreeNodePath other)
        {
            return Length.CompareTo(other.Length);
        }
    }
}
